#!/bin/bash
# graphical knoppix boot
# Copyright (c) 2004 by Fabian Franz
# License: GPL.

START_TTY=$1

splash_exit()
{
	killall fbi
}

[ -f /etc/environment ] && . /etc/environment
[ -f /etc/sysconfig/i18n ] && . /etc/sysconfig/i18n

case "$LANGUAGE" in
de*|at*|ch*)
	KNOPPIX_BOOT="Knoppix wird gestartet."
	VERBOSE="Beliebige Taste fr Textausgabe."
;;
*)
	KNOPPIX_BOOT="Knoppix is booting up."
	VERBOSE="Press any key for verbose mode."
;;
esac

X_RES=$(fbresolution | cut -dx -f1)
Y_RES=$(fbresolution | cut -dx -f2)

trap "splash_exit" EXIT
# preload fbi
fbi --help 2>/dev/null >/dev/null
fbi --vt $START_TTY -q /usr/share/apps/ksplash/pics/splash_top.png
#fbmngplay -S -c $START_TTY -x 420 -y 574 /usr/share/knoppix-splash/bounce.mng &
Y_PENGUIN1=574
L_PENGUIN=100
let X_PENGUIN1=($X_RES-$L_PENGUIN)/2
let X_PENGUIN1_PLUS=$X_PENGUIN1+$L_PENGUIN

let X_FONT=($X_RES-400)/2
let Y_FONT=($Y_RES-243)/2+243+7
PROGRESS_FG="1854b0"
PROGRESS_BG="00277c"

[ -f /usr/share/fonts/truetype/ttf-bitstream-vera/VeraBd.ttf ] && F_FONT="-f /usr/share/fonts/truetype/ttf-bitstream-vera/VeraBd.ttf"
[ -f /usr/share/fonts/truetype/ttf-bitstream-vera/VeraBI.ttf ] && S_FONT="-f /usr/share/fonts/truetype/ttf-bitstream-vera/VeraBI.ttf"

LC_ALL=C sleep 0.5
/sbin/fbtruetype $F_FONT -s 16 -S -c $START_TTY -x $X_FONT  -y $Y_FONT -t "4a84fb" "$KNOPPIX_BOOT"
/sbin/fbtruetype $S_FONT -s 12 -S -c $START_TTY -x 730 -y 700 -t "888888" "$VERBOSE"

/sbin/progress -n -t $START_TTY $[X_FONT+300] $Y_FONT 100 16 "$PROGRESS_BG" < /dev/tty1

# set up fifo
while ! [ -p /etc/sysconfig/progress ]
do
  mkdir -p /etc/sysconfig/
  read PROGRESS < /etc/sysconfig/progress
  rm -f /etc/sysconfig/progress
  mkfifo /etc/sysconfig/progress
  [ -n "$PROGRESS" ] && /sbin/progress -n -t $START_TTY $[X_FONT+300] $Y_FONT $PROGRESS 16 "$PROGRESS_FG" < /dev/tty1
done

update_progress()
{
	while true
	do
	  read PROGRESS < /etc/sysconfig/progress
	  [ -n "$PROGRESS" ] && progress -n -t $START_TTY $[X_FONT+300] $Y_FONT $PROGRESS 16 "$PROGRESS_FG" < /dev/tty1
	done
}

update_progress &

while true
do
	fbmngwalk -l $L_PENGUIN -t 1 -z 0 -S -c $START_TTY -x $X_PENGUIN1 -y $Y_PENGUIN1 /usr/share/knoppix-splash/digger.mng &
#  fbmngwalk -l $L_PENGUIN -t 0 -z 2 -S -c $START_TTY -x $X_PENGUIN1_PLUS -y 16 /usr/share/knoppix-splash/faller.mng &
	wait $!
	fbmngwalk -l $L_PENGUIN -t 1 -z 0 -S -c $START_TTY -x $X_PENGUIN1 -y $Y_PENGUIN1 /usr/share/knoppix-splash/walk_r.mng &
	# fbmngwalk -l $L_PENGUIN -t -1 -z 0 -S -c $START_TTY -x $X_PENGUIN1_PLUS -y $[16+2*$L_PENGUIN] /usr/share/knoppix-splash/bash_r.mng &
	wait $!
	fbmngwalk -l $L_PENGUIN -t -1 -z 0 -S -c $START_TTY -x $X_PENGUIN1_PLUS -y $Y_PENGUIN1 /usr/share/knoppix-splash/walk_l.mng &
	#fbmngwalk -l $L_PENGUIN -t 0 -z -1 -S -c $START_TTY -x $X_PENGUIN1 -y $[16+2*$L_PENGUIN] /usr/share/knoppix-splash/floater.mng &
	wait $!
	fbmngwalk -l $L_PENGUIN -t 1 -z 0 -S -c $START_TTY -x $X_PENGUIN1 -y $Y_PENGUIN1 /usr/share/knoppix-splash/tumble.mng &
	wait $!
done
